﻿using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.BioBoost.Operators.Mutation {

  public class PlantKiller : PlantBasedUtilizationModifier {

    #region Construction & Cloning
    [StorableConstructor]
    public PlantKiller(bool isDeserializing) {}
    public PlantKiller(PlantKiller orig, Cloner cloner) : base(orig, cloner) {}
    public PlantKiller() {}
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlantKiller(this, cloner);
    }
    #endregion

    public override void Redistribute(RealVector utilizations, List<int> supplierIndices) {
      foreach (var i in supplierIndices) {
        utilizations[i] = 0;
      }
    }
  }
}
