﻿using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.BioBoost.Operators.Mutation {

  [StorableClass]
  public class PlantSupplierEqualizer : PlantBasedUtilizationModifier {

    #region Construction & Cloning
    [StorableConstructor]
    public PlantSupplierEqualizer(bool isDeserializing) {}
    public PlantSupplierEqualizer(PlantSupplierEqualizer orig, Cloner cloner) : base(orig, cloner) {}
    public PlantSupplierEqualizer() {}
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlantSupplierEqualizer(this, cloner);
    }
    #endregion

    public override void Redistribute(RealVector utilizations, List<int> supplierIndices) {
      var average = supplierIndices.Select(i => utilizations[i]).Average();
      foreach (var i in supplierIndices) {
        utilizations[i] = average;
      }
    }


  }
}
