﻿using System.Collections.Generic;
using HeuristicLab.BioBoost.Utils;
using HeuristicLab.Common;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.BioBoost.Operators.Mutation {

  [StorableClass]
  public class PlantSupplierRandomizer : PlantBasedUtilizationModifier {

    #region Construction & Cloning
    [StorableConstructor]
    public PlantSupplierRandomizer(bool isDeserializing) {}
    public PlantSupplierRandomizer(PlantSupplierRandomizer orig, Cloner cloner) : base(orig, cloner) {}
    public PlantSupplierRandomizer() {}
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlantSupplierRandomizer(this, cloner);
    }
    #endregion

    public override void Redistribute(RealVector utilizations, List<int> supplierIndices) {
      foreach (var i in supplierIndices) {
        utilizations[i] = EnforceBounds(utilizations[i] * Util.Sqr(Random.NextDouble() + 0.5), i);
      }
    }


  }
}
