﻿using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Random;

namespace HeuristicLab.BioBoost.Operators.Mutation {

  [StorableClass]
  public class PlantSupplierUtilizationExchanger : PlantBasedUtilizationModifier {

    #region Construction & Cloning
    [StorableConstructor]
    public PlantSupplierUtilizationExchanger(bool isDeserializing) {}
    public PlantSupplierUtilizationExchanger(PlantSupplierUtilizationExchanger orig, Cloner cloner) : base(orig, cloner) {}
    public PlantSupplierUtilizationExchanger() {}
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlantSupplierUtilizationExchanger(this, cloner);
    }
    #endregion

    public override void Redistribute(RealVector utilizations, List<int> supplierIndices) {
      var suppliers = supplierIndices.SampleRandom(Random, 2).ToArray();
      if (suppliers.Length >= 2) {
        var temp = utilizations[suppliers[0]];
        utilizations[suppliers[0]] = utilizations[suppliers[1]];
        utilizations[suppliers[1]] = temp;
      }
    }


  }
}
